function [ContributionEst,Filter] = SubstractSource(Observations,Extracted,LFiltreSoustracteurAC,LFiltreSoustracteurC)
% SubstractSource identifie le filtre inverse permettant
% l'annulation des contributions de la source extraite
% des observations.

% On cherche un filtre de longueur 2L+1
% On utilise les moindres carr�e:
% min ||AX-B||^2 : X=(A'A)^-1A'B

% A contient le signal extrait
% B contient les observations

NObs = size(Observations,1);

% Longueur filtre anti-causal
LMax1 = LFiltreSoustracteurAC;
% Longueur filtre causal
LMax2 = LFiltreSoustracteurC;

% Generation de la matrice A:
FirstCol = [Extracted(LMax1+1:end).'; zeros(LMax1,1)];
FirstRow = [Extracted(LMax1+1:-1:1) zeros(1,LMax2)];
A = toeplitz(FirstCol,FirstRow);

% La matrice B contient les observations
B = Observations.';

Filter = (A'*A)\(A'*B);
ContributionEst = (A*Filter).';
